-- In Idris, False is written _|_
-- True is written () (with constructor ii) 

contradiction : _|_ -> A ;

Not : Set -> Set ;
Not A = A -> _|_ ;

aimplnotnota : A -> Not (Not A) ;
-- Proof in Appendix

data Or   : Set -> Set -> Set where
     or_intro_l  : A -> Or A B
  |  or_intro_r  : B -> Or A B ;

{-
In Idris, you get this for free!

OrElim : {C : Or A B -> Set} ->
         ((a : A) -> C (inl a)) ->
         ((b : B) -> C (inr b)) ->
         (s : Or A B) -> C s ;
OrElim f g (inl a) = f a ;
OrElim f g (inr b) = g b ;
-}

data And : Set -> Set -> Set where
     and_intro : A -> B -> And A B ;

and_elim_l : And A B -> A ;
and_elim_l (and_intro a b) = a ;

and_elim_r : And A B -> B ;
and_elim_r (and_intro a b) = b ;

distrandor : And A (Or B C) -> Or (And A B) (And A C) ;
distrandor (and_intro a orbc) = ?distrandor_1 ;

-- Exists A B is in Idris (a : A ** B a) with constructor <| a , b |>

-- Forall x Exists y A (x , y) -> Exists f : X -> Y (Forall x A (x , f x))

choice : {X : Set} -> {Y : Set} -> {A : X -> Y -> Set} ->
         ((x : X) -> (y : Y ** A x y)) ->
         (f : X -> Y ** (x : X) -> A x (f x)) ;
choice F = ?choice_1 ;
----------------------------------------------------------------
--                        APPENDIX                            --
----------------------------------------------------------------

aimplnotnota proof {
        %intro A ;
        %intro a;
        %compute;
        %intro f;
        %fill f a;
        %qed;
};

distrandor_1 proof {
        %intro B , C , A;
        %intro ;
        %induction orbc;
        %intro B' , A' , a';
        %refine or_intro_l;
        %refine and_intro;
        %fill a;
        %fill a';
        %intro B' , C' , c';
        %refine or_intro_r;
        %refine and_intro;
        %fill a;
        %fill c';
        %qed;
};

choice_1 proof {
        %intro Y , X , A;
        %intro;
        %refine Exists;
        %intro x;
        %induction (F x);
        %intro y;
        %intro axy;
        %fill y;
        %intro x;
        %induction (F x);
        %intro y;
        %intro axy;
        %compute;
        %fill axy;
        %qed;
};
