include "preorder.idr";

infixl 4 === ;

syntax (===) x y = (x = y);

repl : X -> Vect X n ;
repl {n = O} x = VNil ;
repl {n = S n} x = x :: repl x ;

fAdd : Vect Float n -> Vect Float n -> Vect Float n;
fAdd VNil VNil = VNil;
fAdd (x :: xs) (y :: ys) = x +. y :: fAdd xs ys;

SumCols : Vect (Vect Float m) n -> Vect Float m ;
SumCols VNil = repl 0.0 ;
SumCols (xs :: xss) = fAdd xs (SumCols xss);

(.*) : Vect Float n -> Vect Float n -> Float;
(.*) VNil      VNil      = 0.0;
(.*) (x :: xs) (y :: ys) = (x *. y) +. (xs .* ys);

(.*.*) : Vect Float n -> Vect (Vect Float n) m -> Vect Float m;
(.*.*) xs VNil = VNil;
(.*.*) xs (ys :: yss) = (xs .* ys) :: (xs .*.* yss); 

Sum : Vect Float n -> Float;
Sum VNil = 0.0;
Sum (x :: xs) = x +. (Sum xs);

lift2 : (X -> Y -> Bool) -> X -> Y -> Set;
-- lift2 f x y = if (f x y) then () else _|_ ;
lift2 f x y = f x y === True;


--- Some floating point properties

lteF : Float -> Float -> Set;
lteF = lift2 (<=.);


lteFRefl : (x : Float) -> ((x <=. x) === True);
lteFTran : (x : Float) -> (x' : Float) -> (x'' : Float) ->
           ((x <=. x') === True) ->
           ((x' <=. x'') === True) ->
           ((x <=. x'') === True);
lteFTotal : (x : Float) -> (x' : Float) ->
           Or ((x <=. x') === True) ((x' <=. x) === True);

floatIsPreorder : IsPreorder (lift2 (<=.));
floatIsPreorder = isPreorder lteFRefl lteFTran;

floatPreorder : Preorder Float;
floatPreorder = mkPreorder lteF floatIsPreorder;

floatOrder : TotalPreorder Float;
floatOrder = mkTotalPreorder floatPreorder lteFTotal;